/*
 * Swagger Basket
 *
 * Корзина товаров
 *
 * The version of the OpenAPI document: 1.0.0
 *
 * Generated by: https://openapi-generator.tech
 */

using System.ComponentModel;
using System.Runtime.Serialization;
using System.Text;
using BasketApp.Api.Adapters.Http.Contract.src.OpenApi.Converters;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;

namespace BasketApp.Api.Adapters.Http.Contract.src.OpenApi.Models;

/// <summary>
/// </summary>
[DataContract]
public class Basket : IEquatable<Basket>
{
    /// <summary>
    ///     Статус
    /// </summary>
    /// <value>Статус</value>
    [TypeConverter(typeof(CustomEnumConverter<StatusEnum>))]
    [JsonConverter(typeof(StringEnumConverter))]
    public enum StatusEnum
    {
        /// <summary>
        ///     Enum CreatedEnum for created
        /// </summary>
        [EnumMember(Value = "created")] CreatedEnum = 1,

        /// <summary>
        ///     Enum ConfirmedEnum for confirmed
        /// </summary>
        [EnumMember(Value = "confirmed")] ConfirmedEnum = 2
    }

    /// <summary>
    ///     Идентификатор корзины
    /// </summary>
    /// <value>Идентификатор корзины</value>
    [DataMember(Name = "id", EmitDefaultValue = true)]
    public Guid Id { get; set; }

    /// <summary>
    ///     Gets or Sets Address
    /// </summary>
    [DataMember(Name = "address", EmitDefaultValue = false)]
    public Address Address { get; set; }

    /// <summary>
    ///     Gets or Sets DeliveryPeriod
    /// </summary>
    [DataMember(Name = "deliveryPeriod", EmitDefaultValue = true)]
    public DeliveryPeriod DeliveryPeriod { get; set; }

    /// <summary>
    ///     Товарные позиции
    /// </summary>
    /// <value>Товарные позиции</value>
    [DataMember(Name = "items", EmitDefaultValue = false)]
    public List<ExistedItem> Items { get; set; }

    /// <summary>
    ///     Статус
    /// </summary>
    /// <value>Статус</value>
    [DataMember(Name = "status", EmitDefaultValue = true)]
    public StatusEnum Status { get; set; }

    /// <summary>
    ///     Returns true if Basket instances are equal
    /// </summary>
    /// <param name="other">Instance of Basket to be compared</param>
    /// <returns>Boolean</returns>
    public bool Equals(Basket other)
    {
        if (other is null) return false;
        if (ReferenceEquals(this, other)) return true;

        return
            (
                Id == other.Id ||
                Id.Equals(other.Id)
            ) &&
            (
                Address == other.Address ||
                (Address != null &&
                 Address.Equals(other.Address))
            ) &&
            (
                DeliveryPeriod == other.DeliveryPeriod ||
                DeliveryPeriod.Equals(other.DeliveryPeriod)
            ) &&
            (
                Items == other.Items ||
                (Items != null &&
                 other.Items != null &&
                 Items.SequenceEqual(other.Items))
            ) &&
            (
                Status == other.Status ||
                Status.Equals(other.Status)
            );
    }

    /// <summary>
    ///     Returns the string presentation of the object
    /// </summary>
    /// <returns>String presentation of the object</returns>
    public override string ToString()
    {
        var sb = new StringBuilder();
        sb.Append("class Basket {\n");
        sb.Append("  Id: ").Append(Id).Append("\n");
        sb.Append("  Address: ").Append(Address).Append("\n");
        sb.Append("  DeliveryPeriod: ").Append(DeliveryPeriod).Append("\n");
        sb.Append("  Items: ").Append(Items).Append("\n");
        sb.Append("  Status: ").Append(Status).Append("\n");
        sb.Append("}\n");
        return sb.ToString();
    }

    /// <summary>
    ///     Returns the JSON string presentation of the object
    /// </summary>
    /// <returns>JSON string presentation of the object</returns>
    public string ToJson()
    {
        return JsonConvert.SerializeObject(this, Formatting.Indented);
    }

    /// <summary>
    ///     Returns true if objects are equal
    /// </summary>
    /// <param name="obj">Object to be compared</param>
    /// <returns>Boolean</returns>
    public override bool Equals(object obj)
    {
        if (obj is null) return false;
        if (ReferenceEquals(this, obj)) return true;
        return obj.GetType() == GetType() && Equals((Basket)obj);
    }

    /// <summary>
    ///     Gets the hash code
    /// </summary>
    /// <returns>Hash code</returns>
    public override int GetHashCode()
    {
        unchecked // Overflow is fine, just wrap
        {
            var hashCode = 41;
            // Suitable nullity checks etc, of course :)

            hashCode = hashCode * 59 + Id.GetHashCode();
            if (Address != null)
                hashCode = hashCode * 59 + Address.GetHashCode();

            hashCode = hashCode * 59 + DeliveryPeriod.GetHashCode();
            if (Items != null)
                hashCode = hashCode * 59 + Items.GetHashCode();

            hashCode = hashCode * 59 + Status.GetHashCode();
            return hashCode;
        }
    }

    #region Operators

#pragma warning disable 1591

    public static bool operator ==(Basket left, Basket right)
    {
        return Equals(left, right);
    }

    public static bool operator !=(Basket left, Basket right)
    {
        return !Equals(left, right);
    }

#pragma warning restore 1591

    #endregion Operators
}